
#include <iostream.h>
#include <kore/kore.h>
#include <kore/componentref.h>
#include <kore/componenttrader.h>
#include <kore/libraryloader.h>
#include <kore/library.h>
#include <kore/interface.h>
#include <kore/librarylocator.h>
#include <kore/metainfo.h>

#include "koretest/testplugin.h"

using namespace kore;
// crap follows; please ignore
#define KORE_TRADER_REF (ComponentTrader::traderRef())
#define KORE_TRADER_IF (KORE_TRADER_REF.instance())
#define KORE_TRADER (dynamic_cast<ComponentTrader*>(KORE_TRADER_IF))

#define KORE_REF_TRADER_SERVICE(tr,srv) ((tr)->registeredComponent(srv))
#define KORE_REF_SERVICE(srv) KORE_REF_TRADER_SERVICE(KORE_TRADER,srv)
#define KORE_IF_REF(ref) ((ref).instance())
#define KORE_IF_TRADER_SERVICE(tr,srv) (KORE_IF_REF(KORE_REF_TRADER_SERVICE(tr,srv)))
#define KORE_IF_SERVICE(srv) (KORE_IF_REF(KORE_REF_SERVICE(srv)))
#define KORE_COMPONENT_DTP_IF(type,iface) 1
// EOC (end-of-crap)

/**
 * Main Kore application.
 * It loads and starts the Kernel
 */
int main(int argc, char* argv[])
{
    ComponentTrader* trader = KORE_TRADER;
    if( trader )
    {
        //cout << "Trader found" << endl;
        LibraryLocator* locator = dynamic_cast<LibraryLocator*>(trader->registeredComponent("/kore/service/locator").instance());
        if( locator )
        {
            //cout << "Locator found" << endl;
            locator->scanDir( ".", false, LibraryLoader::GLOBAL );
        }
        // Component activation test:
        // getting a reference to the component doesn't activate the component
        ComponentRef ref = trader->registeredComponent("/test/service/test");
        // however, getting the actual instance activates the component
        // ("TestPlugin constructor" should be displayed on stdout)
        Interface* inst = ref.instance();
        // further accesses to the instance doesn't activate the component
        // because it already was activated
        inst = ref.instance();
        // Now testing python plugins..
        ref = trader->registeredComponent("/kore/service/python");
        if( ref.isValid() )
        {
            ref.metaInfo()->ddump();
        }
        else
            cerr << "Could not find the python component" << endl;
    }
}
