
#ifndef INTERFACE_H
#define INTERFACE_H

#include <kore/kore.h>

namespace kore
{
    /**
     * Base class for the korelib components.
     * You need to subclass it when writing your own components/plugins.
     * Services provided by this class (not inherited in subclasses):
     * /kore/service/interface
     * /kore/service/none
     */
    class KORE_API Interface
    {
    public:
        /**
         * Default ctor. Implemented in subclasses.
         */
        Interface() {};
        /**
         * Dtor. Implemented in subclasses.
         */
        virtual ~Interface() {}
    };
};

#endif

