/* $Id: componentref.cpp,v 1.1 2002/05/20 14:34:47 xxl Exp $ */
#include <kore/componentref.h>
#include <kore/kore.h>

using namespace kore;
using namespace std;

ComponentRef::ComponentRef()
{
    _proxy = 0;
    //cerr << "ComponentRef(): " << this << endl;
}
ComponentRef::ComponentRef( ComponentProxy* proxy )
{
    _proxy = proxy;
    //cerr << "ComponentRef( proxy: " << proxy << " ): " << this << endl;
}
ComponentRef::ComponentRef( const ComponentRef& other )
{
    _proxy = other._proxy;
    //cerr << "ComponentRef( other: " << &other << " ): " << this << endl;
}
ComponentRef::~ComponentRef()
{
    //cerr << "~ComponentRef(): " << this << endl;
}

ComponentRef& ComponentRef::operator=( const ComponentRef& other )
{
    if( this != &other )
        _proxy = other._proxy;
    return *this;
}

Interface* ComponentRef::instance() const
{
    if( _proxy )
        return _proxy->instance();
    else
        return 0;
}
Interface* ComponentRef::newInstance() const
{
    if( _proxy )
        return _proxy->newInstance();
    else
        return 0;
}

MetaInfo* ComponentRef::metaInfo() const
{
    if( _proxy )
        return _proxy->metaInfo();
    else
        return 0;
}

ComponentProxy* ComponentRef::proxy() const
{
    return _proxy;
}

bool ComponentRef::isValid() const
{
    return _proxy != 0;
}
