
#include <kore/metainfo.h>
#include <kore/componenttrader.h>
#include <kore/librarylocator.h>
#include <kore/libraryloader.h>
#include <kore/library.h>

using namespace kore;
using namespace std;


static const char* libkore_metainfo[][2]=
{
    { "/kore/library", "~kore" },
    { "~kore/name", "kore" },
    { "~kore/description", "This is Korelib itself, seen as a component library" },
    { "~kore/component", "~Component Trader" },
    { "~Component Trader/name", "Component Trader" },
    { "~Component Trader/type", "Trader" },
    { "~Component Trader/class", "ComponentTrader" },
    { "~Component Trader/class/fqn", "kore::ComponentTrader" },
    { "~Component Trader/factory", "kore_trader_factory" },
    { "~Component Trader/description", "The korelib component trader" },
    { "~Component Trader/version", "0.2.0" },
    { "~Component Trader/version/major", "0" },
    { "~Component Trader/version/minor", "2" },
    { "~Component Trader/version/release", "0" },
    { "~Component Trader/api/version", "0.2.0" },
    { "~Component Trader/api/version/major", "0" },
    { "~Component Trader/api/version/minor", "2" },
    { "~Component Trader/api/version/release", "0" },
    { "~Component Trader/service", "/kore/service/trader" },
    { "~Component Trader/service", "/kore/service/none" },
    { "~Component Trader/service", "/kore/service/interface" },
    { "~kore/component", "~Library Locator" },
    { "~Library Locator/name", "Library Locator" },
    { "~Library Locator/type", "Locator" },
    { "~Library Locator/class", "LibraryLocator" },
    { "~Library Locator/class/fqn", "kore::LibraryLocator" },
    { "~Library Locator/factory", "kore_locator_factory" },
    { "~Library Locator/description", "Searches for kore libraries" },
    { "~Library Locator/version", "0.2.0" },
    { "~Library Locator/version/major", "0" },
    { "~Library Locator/version/minor", "2" },
    { "~Library Locator/version/release", "0" },
    { "~Library Locator/api/version", "0.2.0" },
    { "~Library Locator/api/version/major", "0" },
    { "~Library Locator/api/version/minor", "2" },
    { "~Library Locator/api/version/release", "0" },
    { "~Library Locator/service", "/kore/service/locator" },
    { "~Library Locator/service", "/kore/service/none" },
    { "~Library Locator/service", "/kore/service/interface" },
    { "~kore/component", "~Library Loader" },
    { "~Library Loader/name", "Library Loader" },
    { "~Library Loader/type", "Loader" },
    { "~Library Loader/class", "LibraryLoader" },
    { "~Library Loader/class/fqn", "kore::LibraryLoader" },
    { "~Library Loader/factory", "kore_loader_factory" },
    { "~Library Loader/description", "The korelib library loader" },
    { "~Library Loader/version", "0.2.0" },
    { "~Library Loader/version/major", "0" },
    { "~Library Loader/version/minor", "2" },
    { "~Library Loader/version/release", "0" },
    { "~Library Loader/api/version", "0.2.0" },
    { "~Library Loader/api/version/major", "0" },
    { "~Library Loader/api/version/minor", "2" },
    { "~Library Loader/api/version/release", "0" },
    { "~Library Loader/service", "/kore/service/loader" },
    { "~Library Loader/service", "/kore/service/none" },
    { "~Library Loader/service", "/kore/service/interface" },
    { "~kore/component", "~Library" },
    { "~Library/name", "Library" },
    { "~Library/type", "Library" },
    { "~Library/class", "Library" },
    { "~Library/class/fqn", "kore::Library" },
    { "~Library/factory", "kore_library_factory" },
    { "~Library/description", "Korelib library" },
    { "~Library/version", "0.2.0" },
    { "~Library/version/major", "0" },
    { "~Library/version/minor", "2" },
    { "~Library/version/release", "0" },
    { "~Library/api/version", "0.2.0" },
    { "~Library/api/version/major", "0" },
    { "~Library/api/version/minor", "2" },
    { "~Library/api/version/release", "0" },
    { "~Library/service", "/kore/service/library" },
    { "~Library/service", "/kore/service/none" },
    { "~Library/service", "/kore/service/interface" },
    { 0, 0 }
};

kore::MetaInfo* kore_metainfo()
{
    static kore::MetaInfo* info = 0;
    if( !info )
    {
        info = new kore::MetaInfo(libkore_metainfo);
        // time to bootstrap kore (hack ?)

    }
    return info;
}

kore::Interface* kore_trader_factory()
{
    // make sure the Trader is a singletone
    static kore::ComponentTrader* trader = 0;
    if( !trader )
        trader = new ComponentTrader();
    return trader;
}

kore::Interface* kore_locator_factory()
{
    static kore::LibraryLocator* locator = 0;
    if( !locator )
        locator = new LibraryLocator();
    return locator;
}

kore::Interface* kore_loader_factory()
{
    static kore::LibraryLoader* loader = 0;
    if( !loader )
        loader = new LibraryLoader();
    return loader;
}

kore::Interface* kore_library_factory()
{
    // bogus code...
    return new Library();
}

