// C++ interface wrapper code.
//
// Generated by SIP v3.2.4 on Tue May 28 11:14:40 2002
//
// Terms and Conditions
// 
// Copyright (c) 2001 Catalin Climov <catalin@climov.com>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
// IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// 
// Except as contained in this notice, the name of the copyright holder shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from the
// copyright holder.

#include "sipkoreDeclkore.h"
#include "sipkoreInterface.h"


PyObject *sipClass_Interface;

static void sipDealloc_Interface(sipThisType *);

static PyTypeObject sipType_Interface = {
	PyObject_HEAD_INIT(&PyType_Type)
	0,
	sipName_kore_Interface,
	sizeof (sipThisType),
	0,
	(destructor)sipDealloc_Interface,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	Py_TPFLAGS_DEFAULT,
};

// Convert to a sub-class if possible.

PyObject *sipSubClass_Interface(const Interface *sipCpp)
{
	PyObject *sipClass;

#line 29 "sip/interface.sip"
    extern PyObject *sipClass_ComponentTrader, *sipClass_LibraryLoader,
        *sipClass_LibraryLocator, *sipClass_Library;
    sipClass = sipClass_Interface;

    Py_BEGIN_ALLOW_THREADS
    ComponentTrader* trader = reinterpret_cast<ComponentTrader*>( ComponentTrader::traderRef().instance() );
    if( trader )
    {
        ostrstream ostr;
        ostr << (void*)sipCpp << ends;
        char* idbuff = new char[ostr.pcount()+1];
        strcpy( idbuff, ostr.str() );
        //cout << "Looking for ID: " << idbuff <<  endl;

        ComponentRef* refs = trader->registeredComponents();
        ComponentRef ref;
        for( int i=0; refs[i].isValid(); i++ )
            if( refs[i].metaInfo()->find("id") )
                if( !strcmp(refs[i].metaInfo()->find("id"),idbuff ) )
                {
                    ref = refs[i];
                    break;
                }
        delete idbuff;
        bool validRef = ref.isValid();
        if( validRef )
        {
            const char* cn = ref.metaInfo()->find("class");
            if( cn )
            {
                if( !strcmp( cn, "ComponentTrader" ) )
                    sipClass = sipClass_ComponentTrader;
                else if( !strcmp( cn, "LibraryLoader" ) )
                    sipClass = sipClass_LibraryLoader;
                else if( !strcmp( cn, "LibraryLocator" ) )
                    sipClass = sipClass_LibraryLocator;
                else if( !strcmp( cn, "Library" ) )
                    sipClass = sipClass_Library;
                else if( !strcmp( cn, "Interface" ) )
                    sipClass = sipClass_Interface;
            }
        }
    }
    Py_END_ALLOW_THREADS
#line 116 "sipkoreInterface.cpp"

	return sipClass;
}

// Cast a pointer to a type somewhere in its superclass hierachy.

const void *sipCast_Interface(const void *ptr,PyObject *targetClass)
{
	if (targetClass == sipClass_Interface)
		return ptr;

	return NULL;
}

static void sipDealloc_Interface(sipThisType *sipThis)
{
	if (sipThis -> u.cppPtr != NULL)
	{
		if (sipIsPyOwned(sipThis))
		{
			Py_BEGIN_ALLOW_THREADS

			delete (Interface *)sipThis -> u.cppPtr;

			Py_END_ALLOW_THREADS
		}
	}

	sipDeleteThis(sipThis);
}

PyObject *sipNew_Interface(PyObject *sipSelf,PyObject *sipArgs)
{
	static sipExtraType et = {
		sipCast_Interface
	};

	sipThisType *sipThis = NULL;
	const void *sipNew = NULL;
	int sipFlags = SIP_PY_OWNED;
	int sipArgsParsed = 0;

	// See if there is something pending.

	sipNew = sipGetPending(&sipFlags);

	if (sipNew == NULL)
	{
		if (sipParseArgs(&sipArgsParsed,sipArgs,""))
		{
			Py_BEGIN_ALLOW_THREADS
			sipNew = new Interface();
			Py_END_ALLOW_THREADS
		}
	}

	if (sipNew == NULL)
	{
		Interface * a0;

		if (sipParseArgs(&sipArgsParsed,sipArgs,"J1",sipClass_Interface,&a0))
		{
			Py_BEGIN_ALLOW_THREADS
			sipNew = new Interface(*a0);
			Py_END_ALLOW_THREADS
		}
	}

	if (sipNew == NULL)
	{
		sipNoCtor(sipArgsParsed,sipName_kore_Interface);
		return NULL;
	}

	// Wrap the object.

	if ((sipThis = sipCreateThis(sipSelf,sipNew,&sipType_Interface,sipFlags,&et)) == NULL)
	{
		if (sipFlags & SIP_PY_OWNED)
		{
			Py_BEGIN_ALLOW_THREADS

			delete (Interface *)sipNew;

			Py_END_ALLOW_THREADS
		}

		return NULL;
	}

	Py_INCREF(Py_None);
	return Py_None;
}

sipLazyAttrDef sipClassAttrTab_Interface = {
	0, NULL,
	0, NULL,
	0, NULL
};

Interface *sipForceConvertTo_Interface(PyObject *valobj,int *iserrp)
{
	if (*iserrp || valobj == NULL)
		return NULL;

	if (valobj == Py_None || sipIsSubClassInstance(valobj,sipClass_Interface))
		return (Interface *)sipConvertToCpp(valobj,sipClass_Interface,iserrp);

	sipBadClass(sipName_kore_Interface);

	*iserrp = 1;

	return NULL;
}
