#!/usr/bin/python

# begin (copy-paste text)
import __main__

def kore_createMetaInfos( nfoList ):
    nfos = []
    for nfoDict in nfoList:
        nfos = nfos + [ kore.MetaInfo( nfoDict ) ]
    return nfos

def kore_initComponent( nfo ):
    clazz = globals()[ nfo.find("class") ]
    inst = clazz()
    trader = kore.ComponentTrader.traderRef().instance()
    proxy = kore.ComponentProxy( nfo, inst )
    ref = kore.ComponentRef( proxy )
    trader.registerComponent( ref )
    nfo.insert( "id", trader.idAsString( inst ) )
    trader.registerService( "/kore/service/id", ref )
    trader.registerService( trader.idAsService( inst ), ref )

def kore_initComponents( nfos ):
    for nfo in nfos:
        kore_initComponent( nfo )

def kore_init( nfoList ):
    kore_initComponents( kore_createMetaInfos( nfoList ) )
# end(copy-paste text)

# begin (korelib specific text)
import kore

cnfos = [
        {
            "name" : "PyComponent",
            "class" : "PyComponent",
            "class/fqn" : "PyComponent",
            "type" : "Component",
            "factory" : "PyComponent",
            "description" : "Test Python Component",
            "version" : "0.0.1",
            "version/major" : "0",
            "version/minor" : "0",
            "version/release" : "1",
            "api/version" : "0.0.1",
            "api/version/major" : "0",
            "api/version/minor" : "0",
            "api/version/release" : "1",
            "service" : ["/kore/service/none","/kore/service/interface","/kore/service/python"]
        }
    ]

class PyComponent( kore.Interface ):
    def __init__( self ):
        # calling the constructor of the base class
        # is mandatory for kore plugins
        kore.Interface.__init__( self )
        print "PyComponent got initialized"

kore_init( cnfos )

def kore_test_metainfo():
    return cnfos;

# end (korelib specific text)
# begin ("regression" test)
print __name__
print dir()
print globals()
if __name__ == "__main__":
    trader = kore.ComponentTrader.traderRef().instance()
    for comp in trader.registeredComponents("/kore/service/interface"):
        print comp.metaInfo().find("name")
        print comp.instance()

    #trader.registeredComponent("/kore/service/python").metaInfo().ddump()
    print "Done"
# end ("regression" test)
