
#include "pyliblocator.h"
#include <kore/metainfo.h>

#if defined( KORE_WIN32 )
        #ifdef PYKORE_SUPPORT_EXPORTS
                #define PYKORE_SUPPORT_API __declspec(dllexport)
        #else // ! PYKORE_SUPPORT_EXPORTS
                #define PYKORE_SUPPORT_API __declspec(dllimport)
        #endif // PYKORE_SUPPORT_EXPORTS
#elif defined( KORE_BEOS )
        #ifdef PYKORE_SUPPORT_EXPORTS
                #define PYKORE_SUPPORT_API __declspec(dllexport)
        #else // !PYKORE_SUPPORT_EXPORTS
                #define PYKORE_SUPPORT_API __declspec(dllimport)
        #endif // PYKORE_SUPPORT_EXPORTS

#elif defined( KORE_ATHEOS )
        #define PYKORE_SUPPORT_ATHEOS
        #define PYKORE_SUPPORT_API
#else
        #define PYKORE_SUPPORT_API
#endif

extern "C"
{
    PYKORE_SUPPORT_API kore::MetaInfo* pykore_support_metainfo();
    PYKORE_SUPPORT_API kore::Interface* kore_PyLibLocator_factory();
}

static const char* libpykore_support_metainfo[][2] =
{
    { "/kore/library", "~pykore_support" },
    { "~pykore_support/name", "pykore_support" },
    { "~pykore_support/description", "Support library for loading korelib components written in Python" },
    { "~pykore_support/component", "~PyLibLocator" },
    { "~PyLibLocator/class/fqn", "pykore::PyLibLocator" },
    { "~PyLibLocator/class", "PyLibLocator" },
    { "~PyLibLocator/name", "Python Library Locator" },
    { "~PyLibLocator/version/major", "0" },
    { "~PyLibLocator/api/version/major", "0" },
    { "~PyLibLocator/version", "0.0.1" },
    { "~PyLibLocator/api/version", "0.8.0" },
    { "~PyLibLocator/factory", "kore_PyLibLocator_factory" },
    { "~PyLibLocator/api/version/release", "0" },
    { "~PyLibLocator/version/minor", "0" },
    { "~PyLibLocator/api/version/minor", "8" },
    { "~PyLibLocator/description", "LibraryLocator implementation for Python components" },
    { "~PyLibLocator/version/release", "1" },
    { "~PyLibLocator/service", "/kore/service/locator/python" },
    { "~PyLibLocator/service", "/kore/service/locator/py" },
    { "~PyLibLocator/service", "/kore/service/interface" },
    { 0, 0 }
};

kore::MetaInfo* pykore_support_metainfo()
{
    static kore::MetaInfo* info = 0;
    if( !info )
        info = new kore::MetaInfo( libpykore_support_metainfo );
    return info;
}

kore::Interface* kore_PyLibLocator_factory()
{
    static pykore::PyLibLocator* inst = 0;
    if( !inst )
        inst = new pykore::PyLibLocator();
    return inst;
}
